unit BarCodes;

interface

type
TBarCodeType = (bcCodabar, bcCode25, bcCode39, bcCode128, bcEAN13);

type
TBarCode = class(TObject)
         public
               constructor Create;
               function Alphabet(bcType: TBarCodeType): string;
               function Produce(InputStr: string; bcType: TBarCodeType): string;
end;

implementation

constructor TBarCode.Create;
begin
     inherited Create;
end;

function TBarCode.Alphabet(bcType: TBarCodeType): string;
var
   I: Integer;
begin
     case (bcType) of
     bcCodabar: Alphabet := '1234567890-:.$/+';
     bcCode25: Alphabet := '1234567890';
     bcCode39: Alphabet := '1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ+-*/.$% ';
     bcCode128:
     begin
          Alphabet := '';
          for I := 0 to 127 do Result := Result + Char(I);
     end;
     bcEAN13: Alphabet := '1234567890';
     end;
end;

function TBarCode.Produce(InputStr: string; bcType: TBarCodeType): string;
{
 This function returns a string, containing following values
 0 - thin white line
 1 - thin black line
 2 - thick white line
 3 - thick black line

    ,   
 0 -  
 1 -  
 2 -  
 3 -  
}

var
   L: Integer;
   I: Integer;
   Return: string;
begin
     Return := '';
     L := Length(InputStr);
     if (L > 0) then
     case (bcType) of
          bcCodabar:
          begin
               for I :=1 to L do
               begin
                    Return := Return + '0';
                    case UpCase(InputStr[I]) of
                    '1': Return := Return + '1010321';
                    '2': Return := Return + '1012103';
                    '3': Return := Return + '3210101';
                    '4': Return := Return + '1030121';
                    '5': Return := Return + '3010121';
                    '6': Return := Return + '1210103';
                    '7': Return := Return + '1210301';
                    '8': Return := Return + '1230101';
                    '9': Return := Return + '3012101';
                    '0': Return := Return + '1010123';
                    '-': Return := Return + '1012301';
                    '$': Return := Return + '1032101';
                    ':': Return := Return + '3010303';
                    '/': Return := Return + '3030103';
                    '.': Return := Return + '3030301';
                    '+': Return := Return + '1030303';
                    end;
               end;
               Return := '1012321' + Return + '01012321';
          end;
          bcCode25:
          begin
          end;
          bcCode39:
          begin
               for I := 1 to L do
               begin
                    Return := Return + '0';
                    case UpCase(InputStr[I]) of
                    '1': Return := Return + '301210103';
                    '2': Return := Return + '103210103';
                    '3': Return := Return + '303210101';
                    '4': Return := Return + '101230103';
                    '5': Return := Return + '301230101';
                    '6': Return := Return + '103230101';
                    '7': Return := Return + '101210303';
                    '8': Return := Return + '301210301';
                    '9': Return := Return + '103210301';
                    '0': Return := Return + '101230301';
                    'A': Return := Return + '301012103';
                    'B': Return := Return + '103012103';
                    'C': Return := Return + '303012101';
                    'D': Return := Return + '101032103';
                    'E': Return := Return + '301032101';
                    'F': Return := Return + '103032101';
                    'G': Return := Return + '101012303';
                    'H': Return := Return + '301012301';
                    'I': Return := Return + '103012301';
                    'J': Return := Return + '101032301';
                    'K': Return := Return + '301010123';
                    'L': Return := Return + '103010123';
                    'M': Return := Return + '303010121';
                    'N': Return := Return + '101030123';
                    'O': Return := Return + '301030121';
                    'P': Return := Return + '103030121';
                    'Q': Return := Return + '101010323';
                    'R': Return := Return + '301010321';
                    'S': Return := Return + '103010321';
                    'T': Return := Return + '101030321';
                    'U': Return := Return + '321010103';
                    'V': Return := Return + '123010103';
                    'W': Return := Return + '323010101';
                    'X': Return := Return + '121030103';
                    'Y': Return := Return + '321030101';
                    'Z': Return := Return + '123030101';
                    '-': Return := Return + '121010303';
                    '.': Return := Return + '321010301';
                    ' ': Return := Return + '123010301';
                    '*': Return := Return + '121030301';
                    '$': Return := Return + '121212101';
                    '/': Return := Return + '121210121';
                    '+': Return := Return + '121012121';
                    '%': Return := Return + '101212121';
                    end;
               end;
               Return := '121030301' + Return + '0121030301';
          end;
          bcCode128:
          begin
          end;
          bcEAN13:
          begin
          end;
     end;
     Produce := Return;
end;

end.
